/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB® Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB® Code Configurator - v2.25.2
        Device            :  PIC16F1938
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#include "mcc_generated_files/mcc.h"
#include "ir_buff.h"
#include "ir_rcv.h"
#include "ir_send.h"
#include "mcc_generated_files/tmr2.h"

extern volatile uint8_t hum_status;
uint8_t prev_hum = 0;
extern volatile uint8_t time_counter;
uint8_t power_status;
uint8_t prev_power;

void powerOn(void) {
    if (power_status == 0) {
        power_status = 1;
    }
}

void powerOff(void) {
    if (power_status == 1) {
        power_status = 0;
    }
}

void powerCheck(void) {
    if (prev_power != power_status) {
        if (ir_buff_index > 40) {
            LED_CTRL_LAT = 0;
            ir_send();
            LED_PWR_LAT = !power_status;
            LED_CTRL_LAT = 1;
        }
        prev_power = power_status;
    }
}


void changeHumStatus(void) {
    if (hum_status == 0) {
        // いなくなった！
        time_counter = 0;
        TMR2_StartTimer();
    } else {
        // 来た！
        TMR2_StopTimer();
        time_counter = 0;
        powerOn();
    }
}

/*
                         Main application
 */
void main(void) {
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:
    power_status = 1;
    prev_power = power_status;
    hum_status = 1;
    prev_hum = hum_status;

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    LED_WAIT_LAT = 0;
    LED_OK_LAT = 0;
    LED_ERR_LAT = 0;
    LED_HUM_LAT = 0;
    LED_PWR_LAT = !power_status;
    LED_CTRL_LAT = 1;
    printf("\r\n\r\nreset!\r\n\r\n");
    while (1) {
        // Add your application code
        printf("wait sw\r\n");
        while (SW_GetValue() == 1) {
            //check_hum_state();
            LED_WAIT_Toggle();
            LED_HUM_LAT = hum_status;
            if (prev_hum != hum_status) {
                changeHumStatus();
                prev_hum = hum_status;
            }
            powerCheck();
            __delay_ms(100);
        }
        LED_WAIT_LAT = 0;
        if (SW0_GetValue() == 0) {
            LED_REC_LAT = 1;
            LED_OK_LAT = 0;
            LED_ERR_LAT = 0;
            ir_recieve();
            if (ir_buff_index > 60) {
                LED_OK_LAT = 1;
            } else {
                LED_ERR_LAT = 1;
            }
        } else if (ir_buff_index > 60) {
            ir_send();
        } else if (ir_buff_index >= 0) {
            LED_ERR_LAT = 1;
        }
        LED_REC_LAT = 0;
    }
}
/**
 End of File
 */