/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB® Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB® Code Configurator - v2.25.2
        Device            :  PIC16F1938
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set IR_LED aliases
#define IR_LED_TRIS               TRISA0
#define IR_LED_LAT                LATA0
#define IR_LED_PORT               RA0
#define IR_LED_ANS                ANSA0
#define IR_LED_SetHigh()    do { LATA0 = 1; } while(0)
#define IR_LED_SetLow()   do { LATA0 = 0; } while(0)
#define IR_LED_Toggle()   do { LATA0 = ~LATA0; } while(0)
#define IR_LED_GetValue()         RA0
#define IR_LED_SetDigitalInput()    do { TRISA0 = 1; } while(0)
#define IR_LED_SetDigitalOutput()   do { TRISA0 = 0; } while(0)

#define IR_LED_SetAnalogMode()   do { ANSA0 = 1; } while(0)
#define IR_LED_SetDigitalMode()   do { ANSA0 = 0; } while(0)
// get/set LED_WAIT aliases
#define LED_WAIT_TRIS               TRISA1
#define LED_WAIT_LAT                LATA1
#define LED_WAIT_PORT               RA1
#define LED_WAIT_ANS                ANSA1
#define LED_WAIT_SetHigh()    do { LATA1 = 1; } while(0)
#define LED_WAIT_SetLow()   do { LATA1 = 0; } while(0)
#define LED_WAIT_Toggle()   do { LATA1 = ~LATA1; } while(0)
#define LED_WAIT_GetValue()         RA1
#define LED_WAIT_SetDigitalInput()    do { TRISA1 = 1; } while(0)
#define LED_WAIT_SetDigitalOutput()   do { TRISA1 = 0; } while(0)

#define LED_WAIT_SetAnalogMode()   do { ANSA1 = 1; } while(0)
#define LED_WAIT_SetDigitalMode()   do { ANSA1 = 0; } while(0)
// get/set LED_REC aliases
#define LED_REC_TRIS               TRISA2
#define LED_REC_LAT                LATA2
#define LED_REC_PORT               RA2
#define LED_REC_ANS                ANSA2
#define LED_REC_SetHigh()    do { LATA2 = 1; } while(0)
#define LED_REC_SetLow()   do { LATA2 = 0; } while(0)
#define LED_REC_Toggle()   do { LATA2 = ~LATA2; } while(0)
#define LED_REC_GetValue()         RA2
#define LED_REC_SetDigitalInput()    do { TRISA2 = 1; } while(0)
#define LED_REC_SetDigitalOutput()   do { TRISA2 = 0; } while(0)

#define LED_REC_SetAnalogMode()   do { ANSA2 = 1; } while(0)
#define LED_REC_SetDigitalMode()   do { ANSA2 = 0; } while(0)
// get/set LED_OK aliases
#define LED_OK_TRIS               TRISA3
#define LED_OK_LAT                LATA3
#define LED_OK_PORT               RA3
#define LED_OK_ANS                ANSA3
#define LED_OK_SetHigh()    do { LATA3 = 1; } while(0)
#define LED_OK_SetLow()   do { LATA3 = 0; } while(0)
#define LED_OK_Toggle()   do { LATA3 = ~LATA3; } while(0)
#define LED_OK_GetValue()         RA3
#define LED_OK_SetDigitalInput()    do { TRISA3 = 1; } while(0)
#define LED_OK_SetDigitalOutput()   do { TRISA3 = 0; } while(0)

#define LED_OK_SetAnalogMode()   do { ANSA3 = 1; } while(0)
#define LED_OK_SetDigitalMode()   do { ANSA3 = 0; } while(0)
// get/set LED_ERR aliases
#define LED_ERR_TRIS               TRISA4
#define LED_ERR_LAT                LATA4
#define LED_ERR_PORT               RA4
#define LED_ERR_ANS                ANSA4
#define LED_ERR_SetHigh()    do { LATA4 = 1; } while(0)
#define LED_ERR_SetLow()   do { LATA4 = 0; } while(0)
#define LED_ERR_Toggle()   do { LATA4 = ~LATA4; } while(0)
#define LED_ERR_GetValue()         RA4
#define LED_ERR_SetDigitalInput()    do { TRISA4 = 1; } while(0)
#define LED_ERR_SetDigitalOutput()   do { TRISA4 = 0; } while(0)

#define LED_ERR_SetAnalogMode()   do { ANSA4 = 1; } while(0)
#define LED_ERR_SetDigitalMode()   do { ANSA4 = 0; } while(0)
// get/set LED_HUM aliases
#define LED_HUM_TRIS               TRISA5
#define LED_HUM_LAT                LATA5
#define LED_HUM_PORT               RA5
#define LED_HUM_ANS                ANSA5
#define LED_HUM_SetHigh()    do { LATA5 = 1; } while(0)
#define LED_HUM_SetLow()   do { LATA5 = 0; } while(0)
#define LED_HUM_Toggle()   do { LATA5 = ~LATA5; } while(0)
#define LED_HUM_GetValue()         RA5
#define LED_HUM_SetDigitalInput()    do { TRISA5 = 1; } while(0)
#define LED_HUM_SetDigitalOutput()   do { TRISA5 = 0; } while(0)

#define LED_HUM_SetAnalogMode()   do { ANSA5 = 1; } while(0)
#define LED_HUM_SetDigitalMode()   do { ANSA5 = 0; } while(0)
// get/set SW aliases
#define SW_TRIS               TRISA6
#define SW_LAT                LATA6
#define SW_PORT               RA6
#define SW_SetHigh()    do { LATA6 = 1; } while(0)
#define SW_SetLow()   do { LATA6 = 0; } while(0)
#define SW_Toggle()   do { LATA6 = ~LATA6; } while(0)
#define SW_GetValue()         RA6
#define SW_SetDigitalInput()    do { TRISA6 = 1; } while(0)
#define SW_SetDigitalOutput()   do { TRISA6 = 0; } while(0)

// get/set HUM aliases
#define HUM_TRIS               TRISB4
#define HUM_LAT                LATB4
#define HUM_PORT               RB4
#define HUM_WPU                WPUB4
#define HUM_ANS                ANSB4
#define HUM_SetHigh()    do { LATB4 = 1; } while(0)
#define HUM_SetLow()   do { LATB4 = 0; } while(0)
#define HUM_Toggle()   do { LATB4 = ~LATB4; } while(0)
#define HUM_GetValue()         RB4
#define HUM_SetDigitalInput()    do { TRISB4 = 1; } while(0)
#define HUM_SetDigitalOutput()   do { TRISB4 = 0; } while(0)

#define HUM_SetPullup()    do { WPUB4 = 1; } while(0)
#define HUM_ResetPullup()   do { WPUB4 = 0; } while(0)
#define HUM_SetAnalogMode()   do { ANSB4 = 1; } while(0)
#define HUM_SetDigitalMode()   do { ANSB4 = 0; } while(0)
// get/set IR_OUT aliases
#define IR_OUT_TRIS               TRISB5
#define IR_OUT_LAT                LATB5
#define IR_OUT_PORT               RB5
#define IR_OUT_WPU                WPUB5
#define IR_OUT_ANS                ANSB5
#define IR_OUT_SetHigh()    do { LATB5 = 1; } while(0)
#define IR_OUT_SetLow()   do { LATB5 = 0; } while(0)
#define IR_OUT_Toggle()   do { LATB5 = ~LATB5; } while(0)
#define IR_OUT_GetValue()         RB5
#define IR_OUT_SetDigitalInput()    do { TRISB5 = 1; } while(0)
#define IR_OUT_SetDigitalOutput()   do { TRISB5 = 0; } while(0)

#define IR_OUT_SetPullup()    do { WPUB5 = 1; } while(0)
#define IR_OUT_ResetPullup()   do { WPUB5 = 0; } while(0)
#define IR_OUT_SetAnalogMode()   do { ANSB5 = 1; } while(0)
#define IR_OUT_SetDigitalMode()   do { ANSB5 = 0; } while(0)
// get/set SW0 aliases
#define SW0_TRIS               TRISC0
#define SW0_LAT                LATC0
#define SW0_PORT               RC0
#define SW0_SetHigh()    do { LATC0 = 1; } while(0)
#define SW0_SetLow()   do { LATC0 = 0; } while(0)
#define SW0_Toggle()   do { LATC0 = ~LATC0; } while(0)
#define SW0_GetValue()         RC0
#define SW0_SetDigitalInput()    do { TRISC0 = 1; } while(0)
#define SW0_SetDigitalOutput()   do { TRISC0 = 0; } while(0)

// get/set SW1 aliases
#define SW1_TRIS               TRISC1
#define SW1_LAT                LATC1
#define SW1_PORT               RC1
#define SW1_SetHigh()    do { LATC1 = 1; } while(0)
#define SW1_SetLow()   do { LATC1 = 0; } while(0)
#define SW1_Toggle()   do { LATC1 = ~LATC1; } while(0)
#define SW1_GetValue()         RC1
#define SW1_SetDigitalInput()    do { TRISC1 = 1; } while(0)
#define SW1_SetDigitalOutput()   do { TRISC1 = 0; } while(0)

// get/set SW2 aliases
#define SW2_TRIS               TRISC2
#define SW2_LAT                LATC2
#define SW2_PORT               RC2
#define SW2_SetHigh()    do { LATC2 = 1; } while(0)
#define SW2_SetLow()   do { LATC2 = 0; } while(0)
#define SW2_Toggle()   do { LATC2 = ~LATC2; } while(0)
#define SW2_GetValue()         RC2
#define SW2_SetDigitalInput()    do { TRISC2 = 1; } while(0)
#define SW2_SetDigitalOutput()   do { TRISC2 = 0; } while(0)

// get/set SW3 aliases
#define SW3_TRIS               TRISC3
#define SW3_LAT                LATC3
#define SW3_PORT               RC3
#define SW3_SetHigh()    do { LATC3 = 1; } while(0)
#define SW3_SetLow()   do { LATC3 = 0; } while(0)
#define SW3_Toggle()   do { LATC3 = ~LATC3; } while(0)
#define SW3_GetValue()         RC3
#define SW3_SetDigitalInput()    do { TRISC3 = 1; } while(0)
#define SW3_SetDigitalOutput()   do { TRISC3 = 0; } while(0)

// get/set LED_CTRL aliases
#define LED_CTRL_TRIS               TRISC4
#define LED_CTRL_LAT                LATC4
#define LED_CTRL_PORT               RC4
#define LED_CTRL_SetHigh()    do { LATC4 = 1; } while(0)
#define LED_CTRL_SetLow()   do { LATC4 = 0; } while(0)
#define LED_CTRL_Toggle()   do { LATC4 = ~LATC4; } while(0)
#define LED_CTRL_GetValue()         RC4
#define LED_CTRL_SetDigitalInput()    do { TRISC4 = 1; } while(0)
#define LED_CTRL_SetDigitalOutput()   do { TRISC4 = 0; } while(0)

// get/set LED_PWR aliases
#define LED_PWR_TRIS               TRISC5
#define LED_PWR_LAT                LATC5
#define LED_PWR_PORT               RC5
#define LED_PWR_SetHigh()    do { LATC5 = 1; } while(0)
#define LED_PWR_SetLow()   do { LATC5 = 0; } while(0)
#define LED_PWR_Toggle()   do { LATC5 = ~LATC5; } while(0)
#define LED_PWR_GetValue()         RC5
#define LED_PWR_SetDigitalInput()    do { TRISC5 = 1; } while(0)
#define LED_PWR_SetDigitalOutput()   do { TRISC5 = 0; } while(0)

// get/set TX aliases
#define TX_TRIS               TRISC6
#define TX_LAT                LATC6
#define TX_PORT               RC6
#define TX_SetHigh()    do { LATC6 = 1; } while(0)
#define TX_SetLow()   do { LATC6 = 0; } while(0)
#define TX_Toggle()   do { LATC6 = ~LATC6; } while(0)
#define TX_GetValue()         RC6
#define TX_SetDigitalInput()    do { TRISC6 = 1; } while(0)
#define TX_SetDigitalOutput()   do { TRISC6 = 0; } while(0)

// get/set RX aliases
#define RX_TRIS               TRISC7
#define RX_LAT                LATC7
#define RX_PORT               RC7
#define RX_SetHigh()    do { LATC7 = 1; } while(0)
#define RX_SetLow()   do { LATC7 = 0; } while(0)
#define RX_Toggle()   do { LATC7 = ~LATC7; } while(0)
#define RX_GetValue()         RC7
#define RX_SetDigitalInput()    do { TRISC7 = 1; } while(0)
#define RX_SetDigitalOutput()   do { TRISC7 = 0; } while(0)


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize(void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
 */